# class URI::WS

The syntax of `WS` URIs is defined in RFC6455 section 3.

Note that the Ruby `URI` library allows `WS` URLs containing usernames and passwords. This is not legal as per the RFC, but used to be supported in Internet Explorer 5 and 6, before the MS04-004 security update. See <URL:support.microsoft.com/kb/834489>.

### Constants

COMPONENT

  An `Array` of the available components for `URI::WS`.

DEFAULT_PORT

  A Default port of 80 for `URI::WS`.

### Public Class Methods

build (args)
Source

    # File lib/uri/ws.rb, line 56
    def self.build(args)
      tmp = Util.make_components_hash(self, args)
      super(tmp)
    end

## Description¶ ↑

Creates a new `URI::WS` object from components, with syntax checking.

The components accepted are userinfo, host, port, path, and query.

The components should be provided either as an `Array`, or as a `Hash` with keys formed by preceding the component names with a colon.

If an `Array` is used, the components must be passed in the order `[userinfo, host, port, path, query]`.

Example:

    uri = URI::WS.build(host: 'www.example.com', path: '/foo/bar')

    uri = URI::WS.build([nil, "www.example.com", nil, "/path", "query"])

Currently, if passed userinfo components this method generates invalid `WS` URIs as per RFC 1738.

Calls superclass method `URI::Generic::build`

### Public Instance Methods

request_uri ()
Source

    # File lib/uri/ws.rb, line 74
    def request_uri
      return unless @path

      url = @query ? "#@path?#@query" : @path.dup
      url.start_with?(?/.freeze) ? url : ?/ + url
    end

## Description¶ ↑

Returns the full path for a `WS` `URI`, as required by `Net::HTTP::Get`.

If the `URI` contains a query, the full path is URI#path + ‘?’ + URI#query. Otherwise, the path is simply URI#path.

Example:

    uri = URI::WS.build(path: '/foo/bar', query: 'test=true')
    uri.request_uri #  => "/foo/bar?test=true"